// Swap key/value pairs in object
var swapObject = function(obj) {
	var reverseObj = {};
	for(var key in obj) {
		reverseObj[obj[key]] = key;
	}
	return reverseObj;
}

var regulatorIdMap = {
	'BUCK1': 0,
	'BUCK2': 1,
	'BUCK3': 2,
	'BUCK4': 3,
	'BUCK5': 4,
	'LDO1':  8,
	'LDO2':  9,
	'LDO3':  10,
	'LDO4':  11
}
var reverseRegulatorIdMap = swapObject(regulatorIdMap);

var registerIdMap = {
	'R0': '00',
	'R1': '01',
	'R2': '10',
	'R3': '11'
}

var voutSelMap = {
	'VSET1':	'00',
	'VSET2':	'01',
	'ACTIVE':	'10',
	'INACTIVE':	'11',
	'0':		'00',	// Numbers 0-3 can be used instead of the labels
	'1':		'01',
	'2':		'10',
	'3':		'11'
}

var reverseVoutSelMap = {
    '00': 'VSET1',
    '01': 'VSET2',
    '10': 'ACTIVE',
    '11': 'INACTIVE'
}

var conditionSelectMap = {
	'GPIO1':			'000000',
	'GPIO2':			'000001',
	'GPIO3':			'000010',
	'GPIO4': 			'000011',
	'GPIO5':			'000100',
	'GPIO6':			'000101',
	'GPIO7':			'000110',
	'GPIO8':			'000111',
	'GPIO9':			'001000',
	'GPIO10':			'001001',
	'GPIO11':			'001010',
	'BUCK1_PG':			'001011',
	'BUCK2_PG':			'001100',
	'BUCK3_PG':			'001101',
	'BUCK4_PG':			'001110',
	'BUCK5_PG':			'001111',
	'LDO1_PG':			'010000',
	'LDO2_PG':			'010001',
	'LDO3_PG':			'010010',
	'LDO4_PG':			'010011',
	'PGOOD':			'010100',
	'TWARN_EVENT':		'010101',
	'INTERRUPT_PIN':	'010110',
    'VMON1_PG':         '010111',
    'VMON2_PG':         '011000',
	//
	'I2C_0':			'100000',
	'I2C_1':			'100001',
	'I2C_2':			'100010',
	'I2C_3':			'100011',
	'I2C_4':			'100100',
	'I2C_5':			'100101',
	'I2C_6':			'100110',
	'I2C_7':			'100111',
	'SREG0_0':			'101000',
	'SREG0_1':			'101001',
	'SREG0_2':			'101010',
	'SREG0_3':			'101011',
	'SREG0_4':			'101100',
	'SREG0_5':			'101101',
	'SREG0_6':			'101110',
	'SREG0_7':			'101111',
	'LP_STANDBY_SEL':	'110000',
	'0':				'111110',
	'1':				'111111'
}
var reverseConditionSelectMap = swapObject(conditionSelectMap);

var triggerSelectMap = {
	'IMMEDIATE_SHUTDOWN': 		'000000',
	'MCU_POWER_ERROR':			'000001',
	'ORDERLY_SHUTDOWN':			'000010',
	//'N/A':					'000011',
	'FORCE_STANDBY':			'000100',
	'SPMI_WD_BIST_DONE':		'000101',
	'ESM_MCU_ERROR':			'000110',
	'WD_ERROR':					'000111',
	'SOC_POWER_ERROR':			'001000',
	'ESM_SOC_ERROR':			'001001',
	'A':						'001010',
	'WKUP1':					'001011',
	'SU_ACTIVE':				'001100',
	'B':						'001101',
	'WKUP2':					'001110',
	'SU_MCU_ONLY':				'001111',
	'C':						'010000',
	'D':						'010001',
	'SU_STANDBY':				'010010',
	'SU_X':						'010011',
	'WAIT_TIMEOUT':				'010100',
	'GPIO1':					'010101',
	'GPIO2':					'010110',
	'GPIO3':					'010111',
	'GPIO4':					'011000',
	'GPIO5':					'011001',
	'GPIO6':					'011010',
	'GPIO7':					'011011',
	'GPIO8':					'011100',
	'GPIO9':					'011101',
	'GPIO10':					'011110',
	'GPIO11':					'011111',
	'I2C_0':					'100000',
	'I2C_1':					'100001',
	'I2C_2':					'100010',
	'I2C_3':					'100011',
	'I2C_4':					'100100',
	'I2C_5':					'100101',
	'I2C_6':					'100110',
	'I2C_7':					'100111',
	'SREG0_0':					'101000',
	'SREG0_1':					'101001',
	'SREG0_2':					'101010',
	'SREG0_3':					'101011',
	'SREG0_4':					'101100',
	'SREG0_5':					'101101',
	'SREG0_6':					'101110',
	'SREG0_7':					'101111',
	'LP_STANDBY_SEL':			'110000',
	'0':						'111110',
	'1':						'111111'
}
var reverseTriggerSelectMap = swapObject(triggerSelectMap);

var triggerTypeMap = {
	'LOW':  '00',
	'HIGH': '01',
	'RISE': '10',
	'FALL': '11'
}
var reverseTriggerTypeMap = swapObject(triggerTypeMap);

var externalStateMap = {
	'RESET':				0,
	'NVM_LDO_SU':			1,
	'NVM_READ':				2,
	'CHANGE_BG_DELAY':		3,
	'NARROW_LIMITS_DELAY':	4,
	'BOOT_BIST':			5,
	'MISSION_STATES':		6,
	'SAFE_RECOVERY':		7,
	'RUNTIME_BIST':			8,
	'USER_EE_PROG_SU':		9,
	'USER_EE_PROG':			10,
    'LP_STANDBY':           11,
	'OFF':					15
}

var reverseExternalStateMap = swapObject(externalStateMap);
	
var delayModeMap = {
    'MATCH_EN':     '00',
    'MATCH_ALL':    '01',
    'ALWAYS':       '10'
}

var reverseDelayModeMap = swapObject(delayModeMap);

var registerAddressMap = {
    'BUCK1_CTRL':       0x4,
    'BUCK2_CTRL':       0x6,
    'BUCK3_CTRL':       0x8,
    'BUCK4_CTRL':       0xA,
    'BUCK5_CTRL':       0xC,
    'BUCK1_VOUT_1':     0xE,
    'BUCK1_VOUT_2':     0xF,
    'BUCK2_VOUT_1':     0x10,
    'BUCK2_VOUT_2':     0x11,
    'BUCK3_VOUT_1':     0x12,
    'BUCK3_VOUT_2':     0x13,
    'BUCK4_VOUT_1':     0x14,
    'BUCK4_VOUT_2':     0x15,
    'BUCK5_VOUT_1':     0x16,
    'BUCK5_VOUT_2':     0x17,
    'LDO1_CTRL':        0x1D,
    'LDO2_CTRL':        0x1E,
    'LDO3_CTRL':        0x1F,
    'LDO4_CTRL':        0x20,
    'LDO1_VOUT':        0x23,
    'LDO2_VOUT':        0x24,
    'LDO3_VOUT':        0x25,
    'LDO4_VOUT':        0x26
}

// File contents is a string containing the input assembly
// debug is a boolean, when true it will include debug output
var assemble = function (fileContents, debug) {
    
    var programTxt = [];			// Text of each instruction
    var programParsed = [];         // List of parsed fields, before binary is generated
    var programBin = [];			// Binary of each instruction
	var programAddrList = [];		// List of addresses for each instruction
		
	var symbolsAddress = {}; // symbol to address mapping
	var reverseSymbols = {}; // address to symbol mapping
	var symbolsInstructionCount = {};
    var instructionCountToSymbols = {};
    var programAddress = 0;
	
	var results = {
		asm: fileContents,
		dbg: "",
		bin: "",
		testBin: "",
		testTxt: "",
		errors: [],
		warnings: [],
	};
	
	var defaultDelayStep = -1;
	var currentDelayStep = -1;
	var inInitSeq = false;			// Used to set default delay value if there is a SET_DELAY command in the initialization sequence
	var parameters = {};
	var startSeqFound = false;
	var instructionCount = 0;
	
    var lines = fileContents.split("\n");
    
    var instructionSetVersion = 1;
    var optimizeConfig = {
        optRegWrite: false,
        optRegWriteVctrl: false,
        optRegWriteVout: false,
        combineDelays: false
    }
    
    var roundingTolerance = undefined;
	
    // Skip all static information before the sequence.
	// Only look for PFSM_DELAY_STEP to determine the default delay step size from NVM
    for(var lineNum=0; lineNum < lines.length; lineNum++) {
        if(lines[lineNum].indexOf("pfsm_start") === 0) {
            startSeqFound = true;
            break;
        } else if(lines[lineNum].indexOf("PFSM_DELAY_STEP") !== -1) {
			delayValue = parseInt(lines[lineNum].split("=")[1]);
			defaultDelayStep = 50 * Math.pow(2, delayValue);
			currentDelayStep = defaultDelayStep;
		} else if(lines[lineNum].indexOf("instruction_set_version") !== -1) {
            lineFields = lines[lineNum].split(/\s+/);
            if(lineFields[1] == "instruction_set_version") {
                instructionSetVersion = convertStringToInt(lineFields[2]);
            }
        } else if(lines[lineNum].indexOf("enable_optimization") !== -1) {
            lineFields = lines[lineNum].split(/\s+/);
            if(lineFields[1] == "enable_optimization") {
                optimizeConfig.optRegWrite      = (lineFields[2] === 'true');
                optimizeConfig.optRegWriteVctrl = (lineFields[2] === 'true');
                optimizeConfig.optRegWriteVout  = (lineFields[2] === 'true');
                optimizeConfig.combineDelays = (lineFields[2] === 'true');
            }
        } else if(lines[lineNum].indexOf("opt_reg_write") !== -1) {
            lineFields = lines[lineNum].split(/\s+/);
            if(lineFields[1] == "opt_reg_write") {
                optimizeConfig.optRegWrite = (lineFields[2] === 'true');
            }
        } else if(lines[lineNum].indexOf("opt_reg_write_vctrl") !== -1) {
            lineFields = lines[lineNum].split(/\s+/);
            if(lineFields[1] == "opt_reg_write_vctrl") {
                optimizeConfig.optRegWriteVctrl = (lineFields[2] === 'true');
            }
        } else if(lines[lineNum].indexOf("opt_reg_write_vout") !== -1) {
            lineFields = lines[lineNum].split(/\s+/);
            if(lineFields[1] == "opt_reg_write_vout") {
                optimizeConfig.optRegWriteVout = (lineFields[2] === 'true');
            }
        } else if(lines[lineNum].indexOf("opt_combine_delays") !== -1) {
            lineFields = lines[lineNum].split(/\s+/);
            if(lineFields[1] == "opt_combine_delays") {
                optimizeConfig.combineDelays = (lineFields[2] === 'true');
            }
        } else if(lines[lineNum].indexOf("delay_round_tolerance") !== -1) {
            lineFields = lines[lineNum].split(/\s+/);
            if(lineFields[1] == "delay_round_tolerance") {
                tolerance = parseFloat(lineFields[2]);
                if(!isNaN(tolerance)) {
                    roundingTolerance = tolerance;
                }
            }
        }
    }
    if(!startSeqFound) {
		var message = "ERROR: Did not find 'pfsm_start' label.";
		results.errors.push(newError("ERR_NO_PFSM_START", message, ""));
        return results;
    }
    
    if(instructionSetVersion !== 1 && instructionSetVersion !== 2) {
		var message = "ERROR: Invalid instruction version.  Current instruction set versions are 1 or 2.";
		results.errors.push(newError("ERR_INVALID_INSTRUCTION_SET_VERSION", message, instructionSetVersion.toString()));
        return results;
    }
	
    var inTrigSetSection = true;
    var highestTrigIdUsed = -1;
	inInitSeq = true;

    // First pass of program, to find symbol labels.  Store valid instructions in to a program text array for future passes.
    // Also do TRIG_SET validation, and insert blank TRIG_SET commands if any IDs are skipped
    for(; lineNum < lines.length; lineNum++) {
        
		line = lines[lineNum];
		
		if(line.indexOf(";") !== -1) {
			line = line.substring(0, line.indexOf(";")); // Remove comments
		}
		
		line = line.trim();
		
        if(line.indexOf(":") !== -1) {
            symbolName = line.split(":")[0];
			if(symbolsAddress.hasOwnProperty(symbolName)) {
				var message = "ERROR: duplicate label '" + symbolName + "'";
				results.errors.push(newError("ERR_DUPLICATE_LABEL", message, symbolName));
			}
            symbolsAddress[symbolName] = programAddress;
            if(!(programAddress in reverseSymbols)) {
                reverseSymbols[programAddress] = symbolName;
            }
			symbolsInstructionCount[symbolName] = instructionCount;
            
            // Make array of symbols, since multiple labels can be used for same address
            if(instructionCountToSymbols.hasOwnProperty(instructionCount)) {
                instructionCountToSymbols[instructionCount].push(symbolName);
            } else {
                instructionCountToSymbols[instructionCount] = [symbolName];
            }
			line = line.substring(line.indexOf(":")+1).trim();
        }		
		
		if(line === "") {
            continue;
		} else {
            fields = line.split(" ");
			fields = fields.filter(function (el) {
				return el !== "";	// delete empty elements due to multiple consecutive spaces
			});
            command = fields[0];
			programAddrList.push(programAddress)
			
            if(command !== "TRIG_SET") {
                inTrigSetSection = false;
            }
            
			if(command === "LITERAL") {
				try {
					var binary = parseLiteralCommand(fields, line);
					programAddress += binary.length;
				} catch(e) {
					e.instruction = line;
					results.errors.push(e);
					continue;
				}
			} else if(command === "TRIG_SET") {
                
                // TRIG_SET commands must be first in the program, and must be in increasing order.  If there are any gaps, we will auto-fill those with triggers that can never happen.
                if(!inTrigSetSection) {
					var message = "ERROR: TRIG_SET must be the first instructions in the program.  They cannot be after other instructions.";
					results.errors.push(newError("ERR_TRIG_SET_NOT_FIRST", message, value));
                } else {
                    try {
                        // Check ID to see if it's out of order, or if there are any gaps
                        if(instructionSetVersion < 2) {
                            parameters = parseParameters(['DEST', 'ID', 'SEL', 'TYPE', 'IMM', 'EXT'], fields);
                        } else {
                            parameters = parseParameters(['DEST', 'ID', 'SEL', 'TYPE', 'IMM', 'EXT', 'REENTRANT (optional)'], fields);
                        }
                        var id = parseNumber(parameters['ID']);
                    } catch(e) {
                        e.instruction = line;
						results.errors.push(e);
                        continue;
                    }
                    
                    if(id <= highestTrigIdUsed) { // Trigger IDs must be increasing order
						var message = "ERROR: TRIG_SET commands must be in increasing order.  Found ID=" + id + " after ID=" + highestTrigIdUsed;
						results.errors.push(newError("ERR_TRIG_SET_OUT_OF_ORDER", message, ""));
                    } else {    // ID is more than previous command, this is valid
                        if(id !== (highestTrigIdUsed + 1)) {
                            for(var trigId = highestTrigIdUsed+1; trigId < id; trigId++) {                                
                                blankTrigger = "TRIG_SET DEST=pfsm_start ID=" + trigId + " SEL=1 TYPE=LOW IMM=0 EXT=0";
								
								var message = "WARNING: Blank trigger inserted at ID=" + trigId + ".  Re-number the TRIG_SET commands to use consecutive ID numbers to avoid this extra TRIG_SET command.";
								results.warnings.push(newWarning("WARN_INSERT_TRIGGER", message, trigId));
                                
                                programTxt.push(blankTrigger);
                                programAddress += commandLength['TRIG_SET'];
                                instructionCount += 1;                                
                            }
                        }
                        
                        highestTrigIdUsed = id;
                        programAddress += commandLength['TRIG_SET'];
                    }
                }
            } else if(commandLength[command] === undefined) {
				var message = "ERROR: Invalid command: " + command;
				results.errors.push(newError("ERR_INVALID_INSTRUCTION", message, command));
				
                return results;
            } else {
				programAddress += commandLength[command];
			}
            
            programTxt.push(line);
			instructionCount += 1;			
        }
    }
    
    for(var i=0; i<programTxt.length; i++) {
        currentInstruction = programTxt[i];
        var fields = programTxt[i].split(" ");
		fields = fields.filter(function (el) {
			return el !== "";	// delete empty elements due to multiple consecutive spaces
		});
        var command = fields[0];
        
        if(command === "END") {
            programParsed[i] = {command: "END", emitFunction: emitEnd, params: {}};		
			inInitSeq = false;
			currentDelayStep = defaultDelayStep;
        } else if(command === "REG_WRITE_MASK_PAGE0_IMM") {
            
            if(instructionSetVersion < 2) {
				var message = "ERROR: REG_WRITE_MASK_PAGE0_IMM is not supported in instruction set version 1.  Specify later version to use this instruction.";
				var e = newError("ERR_INVALID_INSTRUCTION", message, command);
				e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            try{
                parameters = parseParameters(['ADDR', 'DATA', 'MASK'], fields);
                
                var addr = parseNumber(parameters['ADDR'], 8, 'address');
                var data = parseNumber(parameters['DATA'], 8, 'data');
                var mask = parseNumber(parameters['MASK'], 8, 'mask');
            } catch (e) {
                e.instruction = currentInstruction;
                results.errors.push(e);
                continue;
            }
            
            var params = {addr: addr, data: data, mask: mask}
            programParsed[i] = {command: "REG_WRITE_MASK_PAGE0_IMM", emitFunction: emitRegWriteMaskPage0Imm, params: params};
            
        } else if (command === "REG_WRITE_BIT_PAGE0_IMM") {
            
            if(instructionSetVersion < 2) {
				var message = "ERROR: REG_WRITE_BIT_PAGE0_IMM is not supported in instruction set version 1.  Specify later version to use this instruction.";
				var e = newError("ERR_INVALID_INSTRUCTION", message, command);
				e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            try {
                parameters = parseParameters(['ADDR', 'BIT', 'DATA'], fields);
                
                var addr = parseNumber(parameters['ADDR'], 8, 'address');
                var bitSel = parseNumber(parameters['BIT'], 3, 'bit select');
                var data = parseBit(parameters['DATA'], 'data');
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            var params = {addr: addr, data: data, bitSel: bitSel};
            programParsed[i] = {command: "REG_WRITE_BIT_PAGE0_IMM", emitFunction: emitRegWriteBitPage0Imm, params: params};
            
        } else if(command === "REG_WRITE_WIN_PAGE0_IMM") {
            
            if(instructionSetVersion < 2) {
				var message = "ERROR: REG_WRITE_WIN_PAGE0_IMM is not supported in instruction set version 1.  Specify later version to use this instruction.";
				var e = newError("ERR_INVALID_INSTRUCTION", message, command);
				e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            try {
                parameters = parseParameters(['ADDR', 'DATA', 'MASK', 'SHIFT'], fields);
                
                var addr = parseNumber(parameters['ADDR'], 8, 'address');
                var data = parseNumber(parameters['DATA'], 5, 'data');
                var mask = parseNumber(parameters['MASK'], 5, 'mask');
                var shift = parseNumber(parameters['SHIFT'], 2, 'shift');
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            var params = {addr: addr, data: data, mask: mask, shift: shift};
            programParsed[i] = {command: "REG_WRITE_WIN_PAGE0_IMM", emitFunction: emitRegWriteWinPage0Imm, params: params};
            
        } else if(command === "SREG_WRITE_IMM") {
            
            if(instructionSetVersion < 2) {
				var message = "ERROR: SREG_WRITE_IMM is not supported in instruction set version 1.  Specify later version to use this instruction.";
				var e = newError("ERR_INVALID_INSTRUCTION", message, command);
				e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            try {
                parameters = parseParameters(['REG', 'DATA'], fields);
                
                var sreg = parseFieldFromMap(registerIdMap, parameters['REG'], 'register');
                var data = parseNumber(parameters['DATA'], 8, 'data');
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            var params = {sreg: sreg, data: data};
            programParsed[i] = {command: "SREG_WRITE_IMM", emitFunction: emitSregWriteImm, params: params};
            
        } else if(command === "REG_WRITE_IMM") {
			
            try {
                parameters = parseParameters(["ADDR", "DATA"], fields);
                var addr = parseAddress(parameters['ADDR']);
                var data = parseNumber(parameters['DATA'], 8, 'data');
                
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            var params = {addr: addr, data: data};
			programParsed[i] = {command: "REG_WRITE_IMM", emitFunction: emitRegWriteImm, params: params};
			
		} else if(command === "SET_DELAY") {
			
            try {
                parameters = parseParameters(["STEP"], fields);
                
                var delayValue = parseDelayStep(parameters["STEP"], roundingTolerance);
                currentDelayStep = 50 * Math.pow(2, delayValue);
                if(inInitSeq) {
                    defaultDelayStep = currentDelayStep;
                }
                
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
						
			// Address for PFSM_DELAY_STEP register is 0x8B
            var params = {addr: 0x8B, data: delayValue};
            programParsed[i] = {command: "REG_WRITE_IMM", emitFunction: emitRegWriteImm, params: params};
			
		} else if(command === "REG_WRITE_MASK_IMM") {
			
            try {
                parameters = parseParameters(['ADDR', 'DATA', 'MASK'], fields);
                
                var addr = parseAddress(parameters['ADDR']);
                var data = parseNumber(parameters['DATA'], 8, 'data');
                var mask = parseNumber(parameters['MASK'], 8, 'mask');
                
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            var params = {addr: addr, data: data, mask: mask};
            var parsedInstruction = {command: "REG_WRITE_MASK_IMM", emitFunction: emitRegWriteMaskImm, params: params};
            
            
            programParsed[i] = parsedInstruction;
			
		} else if(command === "REG_WRITE_VOUT_IMM") {
			
            try {
                parameters = parseParameters(['REGULATOR', 'SEL', 'VOUT', 'DELAY', 'BYPASS (optional)'], fields);
                
                var regulator = parseFieldFromMap(regulatorIdMap, parameters['REGULATOR'], 'regulator');
                var sel = parseFieldFromMap(voutSelMap, parameters['SEL'], 'VSEL');
                var vset = parseVoutToVset(parameters['VOUT'], parameters['REGULATOR'], parameters['BYPASS'], results.warnings);
                var delay = parseDelay(parameters['DELAY'], currentDelayStep, 6, roundingTolerance, results.warnings);
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
			
            var params = {regulator: regulator, sel: sel, vset: vset, delay: delay};
			var parsedInstruction = {command: "REG_WRITE_VOUT_IMM", emitFunction: emitRegWriteVoutImm, params: params};
            
            
            programParsed[i] = parsedInstruction;
			
		} else if(command === "REG_WRITE_VCTRL_IMM") {
			
            try {
                parameters = parseParameters(['REGULATOR', 'VCTRL', 'MASK', 'DELAY', 'DELAY_MODE'], fields);
                
                var regulator = parseFieldFromMap(regulatorIdMap, parameters['REGULATOR'], 'regulator');
                var vctrl = parseNumber(parameters['VCTRL'], 8, 'VCTRL');
                var mask = parseNumber(parameters['MASK'], 8, 'mask');
                var delay = parseDelay(parameters['DELAY'], currentDelayStep, 6, roundingTolerance, results.warnings);
                var delayMode = parseFieldFromMap(delayModeMap, parameters['DELAY_MODE'], 'delay mode');
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
			
            var params = {regulator: regulator, delayMode: delayMode, vctrl: vctrl, mask: mask, delay: delay};
            var parsedInstruction = {command: "REG_WRITE_VCTRL_IMM", emitFunction: emitRegWriteVctrlImm, params: params};
            
            
            programParsed[i] = parsedInstruction;
			
		} else if(command === "REG_WRITE_MASK_SREG") {
			
            try {
                parameters = parseParameters(['REG', 'ADDR', 'MASK'], fields);
                var sreg = parseFieldFromMap(registerIdMap, parameters['REG'], 'register');
                var addr = parseAddress(parameters['ADDR']);
                var mask = parseNumber(parameters['MASK'], 8, 'mask');
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;                
            }
			
            var params = {addr: addr, sreg: sreg, mask: mask};
			programParsed[i] = {command: "REG_WRITE_MASK_SREG", emitFunction: emitRegWriteMaskSreg, params: params};
			
		} else if(command === "SREG_READ_REG") {
			
            try {
                parameters = parseParameters(['REG', 'ADDR'], fields);
                
                var sreg = parseFieldFromMap(registerIdMap, parameters['REG'], 'register');
                var addr = parseAddress(parameters['ADDR']);
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
			
            var params = {addr: addr, sreg: sreg};
			programParsed[i] = {command: "SREG_READ_REG", emitFunction: emitSregReadReg, params: params};
			
			
		} else if(command === "WAIT") {
			
            try {
                // Note, either DEST or SKIP_COUNT must be present
                parameters = parseParameters(['COND', 'TYPE', 'TIMEOUT', 'DEST (optional)', 'SKIP_COUNT (optional)'], fields);
                
                if(parameters['DEST'] === undefined && parameters['SKIP_COUNT'] === undefined) {
					var message = "ERROR: Must specify either DEST or SKIP_COUNT";
                    throw(newError("ERR_WAIT_NO_SKIP_OR_DEST", message, ""));
                }
                if(parameters['DEST'] !== undefined && parameters['SKIP_COUNT'] !== undefined) {
					var message = "ERROR: Cannot specify both DEST and SKIP_COUNT.  Specify one or the other";
                    throw(newError("ERR_WAIT_BOTH_SKIP_AND_DEST", message, ""));
                }
                
                var condition = parseFieldFromMap(conditionSelectMap, parameters['COND'], 'condition');
                var conditionType = parseFieldFromMap(triggerTypeMap, parameters['TYPE'], 'condition type'); // trigger types and condition types are the same
                var timeout = parseDelay(parameters['TIMEOUT'], currentDelayStep, 6, roundingTolerance, results.warnings);
                
                if(parameters['DEST'] !== undefined) {  // DEST provided instead of SKIP_COUNT
                    var skipCount = parseDestinationToSkipCount(parameters['DEST'], symbolsInstructionCount, i);    // 'i' contains current instruction count
                } else {                                // SKIP_COUNT provided instead of DEST
                    var skipCount = parseNumber(parameters['SKIP_COUNT'], 6, 'skip count');
                }
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
			
            var params = {condition: condition, conditionType: conditionType, timeout: timeout, skipCount: skipCount, destLabel: parameters['DEST']};
			programParsed[i] = {command: "WAIT", emitFunction: emitWait, params: params};
			
		} else if(command === "JUMP") {
			
            try {
                parameters = parseParameters(['DEST'], fields);
                
                var skipCount = parseDestinationToSkipCount(parameters['DEST'], symbolsInstructionCount, i);
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
            
            var condition = parseFieldFromMap(conditionSelectMap, '1', 'condition');
            var conditionType = parseFieldFromMap(triggerTypeMap, 'LOW', 'condition type');
			
            var params = {condition: condition, conditionType: conditionType, timeout: 0, skipCount: skipCount};
			programParsed[i] = {command: "WAIT", emitFunction: emitWait, params: params};		
			
		} else if(command === "DELAY_IMM") {
			
            try {
                parameters = parseParameters(['DELAY'], fields);
                
                var delay = parseDelay(parameters['DELAY'], currentDelayStep, 8, roundingTolerance, results.warnings);
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }
			
            var params = {delay: delay};
			programParsed[i] = {command: "DELAY_IMM", emitFunction: emitDelayImm, params: params};
			
		} else if(command === "DELAY_SREG") {
			
            try {
                parameters = parseParameters(['REG'], fields);
                
                var sreg = parseFieldFromMap(registerIdMap, parameters['REG'], 'register');
			} catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
				continue;
			}
			
            var params = {sreg: sreg};
			programParsed[i] = {command: "DELAY_SREG", emitFunction: emitDelaySreg, params: params};			
			
		} else if(command === "TRIG_SET") {

            try {
                if(instructionSetVersion < 2) {
                    parameters = parseParameters(['DEST', 'ID', 'SEL', 'TYPE', 'IMM', 'EXT'], fields);
                } else {
                    parameters = parseParameters(['DEST', 'ID', 'SEL', 'TYPE', 'IMM', 'EXT', 'REENTRANT (optional)'], fields);
                }
                
                var ext = parseBit(parameters['EXT'], 'external');
                var imm = parseBit(parameters['IMM'], 'immediate');
                
                if(ext === 0) {
                    var destination = parseDestinationToAddress(parameters['DEST'], symbolsAddress);
                } else {
                    var destination = parseFieldFromMap(externalStateMap, parameters['DEST'], 'destination');
                }
                
                var trigId = parseTriggerId(parameters['ID']);
                var trigSel = parseFieldFromMap(triggerSelectMap, parameters['SEL'], 'trigger select');
                var trigType = parseFieldFromMap(triggerTypeMap, parameters['TYPE'], 'trigger type');
                
                var reentrant = 0;
                if(instructionSetVersion >= 2 && parameters['REENTRANT'] !== undefined) {
                    reentrant = parseBit(parameters['REENTRANT'], 'reentrant');
                    
                    // If imm and reentrant are both 1, trigger will repeatedly take itself and never complete.
                    if(imm === 1 && reentrant === 1) {
						var message = "ERROR: IMM and REENTRANT cannot both be 1";
						throw(newError("ERR_TRIG_SET_IMM_REENTRANT", message, ""));
                    }
                }
                
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
				continue;
			}

            var params = {trigId: trigId, trigSel: trigSel, trigType: trigType, imm: imm, ext: ext, destination: destination, reentrant: reentrant, instructionSetVersion: instructionSetVersion, destLabel: parameters['DEST']};
            programParsed[i] = {command: "TRIG_SET", emitFunction: emitTrigSet, params: params};
			
			
		} else if(command === "TRIG_MASK") {
			if(fields.length !== 2) {
				var message = "ERROR: Expected 1 argument, found " + (fields.length - 1);
				var e = newError("ERR_WRONG_NUMBER_OF_ARGUMENTS", message, "");
				e.instruction = currentInstruction;
				results.errors.push(e);
				continue;
			}
            
			try {
				var trigMask = parseNumber(fields[1], 28, "trigger mask");
			} catch (e) {
				e.instruction = currentInstruction;
				results.errors.push(e);
				continue;
			}
            
            var params = {trigMask: trigMask};
			programParsed[i] = {command: "TRIG_MASK", emitFunction: emitTrigMask, params: params};
            
		} else if(command === "LITERAL") {
			if(fields.length === 1) {
				var message = "ERROR: Expected 1 argument, found " + (fields.length - 1);
				var e = newError("ERR_WRONG_NUMBER_OF_ARGUMENTS", message, "");
				e.instruction = currentInstruction;
				results.errors.push(e);
				continue;
			}
			
            try {
                var binary = parseLiteralCommand(fields);
            } catch (e) {
                e.instruction = currentInstruction;
				results.errors.push(e);
                continue;
            }

            var params = {binary: binary};
			programParsed[i] = {command: "LITERAL", emitFunction: emitLiteral, params: params};
		}
        
        if(instructionCountToSymbols.hasOwnProperty(i)) {
            programParsed[i].labels = instructionCountToSymbols[i];
        } else {
            programParsed[i].labels = [];
        }
		
    }
    
    if(results.errors.length > 0) {
        return results;
    }
    
    // Remove unused labels.  This allows optimizing delays with labels which were never used.
    var usedLabels = [];
    programParsed.forEach(function(parsed) {
       if(parsed.params.hasOwnProperty('destLabel')) {
           usedLabels.push(parsed.params.destLabel);
       }
    });
    programParsed.forEach(function(parsed) {
        var newLabels = [];
        parsed.labels.forEach(function(label) {
            if(usedLabels.includes(label) || label == 'pfsm_start') { // pfsm_start is required for DV
               newLabels.push(label); 
            }
        });
        parsed.labels = newLabels;
    });
    
    // Run optimizations
    programParsed = optimizeProgram(programParsed, optimizeConfig, instructionSetVersion);

    
    // Update address length and symbol table, since some instructions may have been optimized
    var address = 0;
    
    reverseSymbols = {};
    symbolsAddress = {};
    programAddrList = [];
    // First, update address of every instruction
    for(i=0; i<programParsed.length; i++) {
        var instructionLength;
        if(programParsed[i].command === "LITERAL") {
            instructionLength = programParsed[i].params.binary.length;
        } else {
            instructionLength = commandLength[programParsed[i].command];
        }
        programAddrList[i] = address;
        address += instructionLength;
        
        programParsed[i].labels.forEach(function(symbol) {
            symbolsAddress[symbol] = programAddrList[i];
            symbolsInstructionCount[symbol] = i;
            reverseSymbols[i] = symbol;
        });
    }
    
    // Finally, update the TRIG_SET commands to use the new addresses
    for(i=0; i<programParsed.length; i++) {
        if(programParsed[i].command === "TRIG_SET" && programParsed[i].params.ext === 0) {
            programParsed[i].params.destination = symbolsAddress[programParsed[i].params.destLabel];
        } else if(programParsed[i].command === "WAIT" && programParsed[i].destLabel !== undefined) {
            programParsed[i].params[skipCount] = parseDestinationToSkipCount(programParsed[i].destLabel, symbolsInstructionCount, i);
        }
    }
    
    for(i=0; i<programParsed.length; i++) {
        programBin[i] = programParsed[i].emitFunction(programParsed[i].params);
    }
    
	var dbgString = createDebugString(programParsed, programAddrList, reverseSymbols);
	if(debug) {
		console.log(symbolsAddress);
		console.log(symbolsInstructionCount);
		console.log(programTxt);
		console.log(programBin);
		console.log(dbgString);
	}
	
    var binaryString = formatBits(programBin);

    results.asm = fileContents;
    results.dbg = dbgString;
    results.bin = binaryString;
    results.testBin = programBin;
    results.testTxt = programTxt;
    return results;
}

var disassemble = function(binaryTxt) {
	
	var lines = binaryTxt.split(/\s+/); // split on any whitespace
	var binaryString = "";
	var binaryIndex = 0;
	var instructionList = [];
	var instructionLength = 0;
	
	for(var i=0; i<lines.length; i++) {
		binaryString = lines[i] + binaryString;
	}
	
	var endSeq = false;
    var instructionSetVersion = 1;
	
	while(binaryIndex < binaryString.length) {
		var command = binaryString.substring(binaryString.length-binaryIndex-4, binaryString.length-binaryIndex);
		var instruction = {"address": "0x" + zeroPad(binaryIndex.toString(16), 4)};
			
		if(command === '0000') {
            var remainingBits = binaryString.length-binaryIndex;
            if(remainingBits < commandLength['REG_WRITE_MASK_PAGE0_IMM']) { // If command is '0000' and instruction is too short, it means we're at the end of the program
                if(binaryString.substring(0, remainingBits) === '0'.repeat(remainingBits)) { // We're just reading the zero-fill
                    break;
                } else {  // Some invalid instruction at the end of the program
                    console.log("Invalid command.  Found '" + binaryString.substring(0, remainingBits) + "' at the end of the program");
                    break;
                }
            } else { // REG_WRITE_MASK_PAGE0_IMM
				instructionLength = commandLength['REG_WRITE_MASK_PAGE0_IMM'];
                var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
                var mask = zeroPad(parseInt(instructionBin.substring(0, 8), 2).toString(16).toUpperCase(), 2);
                var data = zeroPad(parseInt(instructionBin.substring(8, 16), 2).toString(16).toUpperCase(), 2);
                var addr = zeroPad(parseInt(instructionBin.substring(16, 24), 2).toString(16).toUpperCase(), 2);
                
                instruction["assembly"] = "REG_WRITE_MASK_PAGE0_IMM ADDR=0x" + addr + " DATA=0x" + data + " MASK=0x" + mask;
                instructionSetVersion = 2;
                endSeq = false;
			}
		} else if(command === '0001') { // REG_WRITE_IMM
			instructionLength = commandLength['REG_WRITE_IMM'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			data = zeroPad(parseInt(instructionBin.substring(0, 8), 2).toString(16).toUpperCase(), 2);
			addr = parseInt(instructionBin.substring(8, 18), 2);
            if(addr >= 0x300) {
                addr += 0x100;
            }
            addr = zeroPad(addr.toString(16).toUpperCase(), 3);
			
			instruction["assembly"] = "REG_WRITE_IMM ADDR=0x" + addr.toString(16) + " DATA=0x" + data.toString(16);
			endSeq = false;
		} else if(command === '0010') { // REG_WRITE_MASK_IMM
			instructionLength = commandLength['REG_WRITE_MASK_IMM'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			mask = zeroPad(parseInt(instructionBin.substring(0, 8), 2).toString(16).toUpperCase(), 2);
			data = zeroPad(parseInt(instructionBin.substring(8, 16), 2).toString(16).toUpperCase(), 2);
			addr = parseInt(instructionBin.substring(16,26), 2);
            if(addr >= 0x300) {
                addr += 0x100;
            }
            addr = zeroPad(addr.toString(16).toUpperCase(), 3);
			instruction["assembly"] =  "REG_WRITE_MASK_IMM ADDR=0x" + addr.toString(16) + " DATA=0x" + data.toString(16) + " MASK=0x" + mask;
			endSeq = false;
		} else if(command === '0011') { // REG_WRITE_VOUT_IMM
			instructionLength = commandLength['REG_WRITE_VOUT_IMM'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			delay = parseInt(instructionBin.substring(0, 6), 2);
			vout = parseInt(instructionBin.substring(6, 14), 2);
			selBin = instructionBin.substring(14, 16);
			sel = reverseVoutSelMap[selBin];
			regulatorId = parseInt(instructionBin.substring(16,20), 2);
			regulator = reverseRegulatorIdMap[regulatorId];
			
			// Convert vout binary to voltage
			var voutVolts;
			var bypass;
			if(regulator.substring(0,4) === "BUCK") {
				if(vout <= 0x0E) {
					voutVolts = vout * 0.02 + 0.3;
				} else if(vout <= 0x72) {
					voutVolts = vout * 0.005 + 0.525;
				} else if(vout <= 0xAA) {
					voutVolts = vout * 0.01 - 0.05;
				} else {
					voutVolts = vout * 0.02 - 1.76;
				}
			} else { // LDO
				if(regulator === "LDO4") {
					voutVolts = vout * 0.025 + 0.4;
					bypass = "0";
				} else {
					if((vout & 0x80) === 0x80) {
						bypass = "1";
						vout = vout & 0x7F;
					} else {
						bypass = "0";
					}
					
					voutVolts = (vout >> 1) * 0.05 + 0.4;
				}
			}
			
			voutVolts = Math.round(voutVolts * 1000) / 1000; // Round to 3 decimal places
			
			instruction["assembly"] = "REG_WRITE_VOUT_IMM DELAY=" + delay + " VOUT=" + voutVolts + "V SEL=" + sel + " REGULATOR=" + regulator;
			if(regulator.substring(0,3) === "LDO") {
				instruction["assembly"] += " BYPASS=" + bypass;
			}
			
			endSeq = false;
		} else if(command === '0100') { // REG_WRITE_VCTRL_IMM
			instructionLength = commandLength['REG_WRITE_VCTRL_IMM'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			delay = parseInt(instructionBin.substring(0, 6), 2);
			mask = zeroPad(parseInt(instructionBin.substring(6,14), 2).toString(16).toUpperCase(), 2);
			vctrl = zeroPad(parseInt(instructionBin.substring(14, 22), 2).toString(16).toUpperCase(), 2);
			delayModeBin = instructionBin.substring(22, 24);
			delayMode = reverseDelayModeMap[delayModeBin];
			regulatorId = parseInt(instructionBin.substring(24, 28), 2);
			regulator = reverseRegulatorIdMap[regulatorId];
			
			instruction["assembly"] = "REG_WRITE_VCTRL_IMM DELAY=" + delay + " MASK=0x" + mask + " VCTRL=0x" + vctrl + " DELAY_MODE=" + delayMode + " REGULATOR=" + regulator;
			endSeq = false;
		} else if(command === '0101') { // REG_WRITE_MASK_SREG
			instructionLength = commandLength['REG_WRITE_MASK_SREG'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			mask = zeroPad(parseInt(instructionBin.substring(0, 8), 2).toString(16).toUpperCase(), 2);
			sregId = parseInt(instructionBin.substring(8, 10), 2);
			sreg = "R" + sregId;
			addr = zeroPad(parseInt(instructionBin.substring(10, 20), 2).toString(16).toUpperCase(), 3);
			
			instruction["assembly"] = "REG_WRITE_MASK_SREG REG=" + sreg + " ADDR=0x" + addr + " MASK=0x" + mask;
			endSeq = false;
		} else if(command === '0110') { // SREG_READ_REG
			instructionLength = commandLength['SREG_READ_REG'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			sregId = parseInt(instructionBin.substring(0, 2), 2);
			sreg = "R" + sregId;
			addr = zeroPad(parseInt(instructionBin.substring(2,12), 2).toString(16).toUpperCase(), 3);
			
			instruction["assembly"] = "SREG_READ_REG REG=" + sreg + " ADDR=0x" + addr;
			endSeq = false;
		} else if(command === '0111') { // WAIT
			instructionLength = commandLength['WAIT'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			skipCount = parseInt(instructionBin.substring(0, 6), 2);
			timeout = parseInt(instructionBin.substring(6,12), 2);
			conditionTypeBin = instructionBin.substring(12,14);
			conditionType = reverseTriggerTypeMap[conditionTypeBin];
			conditionSelBin = instructionBin.substring(14,20);
			conditionSel = reverseConditionSelectMap[conditionSelBin];
			
			instruction["assembly"] = "WAIT SKIP_COUNT=" + skipCount + " TIMEOUT=" + timeout + " COND=" + conditionSel + " TYPE=" + conditionType;
			endSeq = false;
		} else if(command === '1000') { // DELAY_IMM
			instructionLength = commandLength['DELAY_IMM'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			delay = parseInt(instructionBin.substring(0,8), 2);
			
			instruction["assembly"] = "DELAY_IMM " + delay;
			endSeq = false;
		} else if(command === '1001') { // DELAY_SREG
			instructionLength = commandLength['DELAY_SREG'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			sreg = "R" + parseInt(instructionBin.substring(0,2), 2);
			instruction["assembly"] = "DELAY_SREG " + sreg;
			endSeq = false;
		} else if(command === '1010') { // TRIG_SET
			instructionLength = commandLength['TRIG_SET'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
            reentrant = undefined;
			
            addr = parseInt(instructionBin.substring(0,13), 2);
            ext = instructionBin.substring(13,14);
			imm = instructionBin.substring(14,15);
			trigType = reverseTriggerTypeMap[instructionBin.substring(15,17)];
			trigSel = reverseTriggerSelectMap[instructionBin.substring(17,23)];
			trigId = parseInt(instructionBin.substring(23,28), 2);
            
			if(ext === "1") {
				addr = reverseExternalStateMap[addr];
			} else {
                if(addr % 2 === 1) {
                    reentrant = 1;
                    addr -= 1;
                }
				addr = "0x" + zeroPad(addr.toString(16), 4);
			}
			
            if(reentrant === undefined) {
                instruction["assembly"] = "TRIG_SET DEST=" + addr + " ID=" + trigId + " SEL=" + trigSel + " TYPE=" + trigType + " IMM=" + imm + " EXT=" + ext;
            } else {
                instruction["assembly"] = "TRIG_SET DEST=" + addr + " ID=" + trigId + " SEL=" + trigSel + " TYPE=" + trigType + " IMM=" + imm + " EXT=" + ext + " REENTRANT=" + reentrant;
            }
			endSeq = false;
		} else if(command === '1011') { // TRIG_MASK
			instructionLength = commandLength['TRIG_MASK'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			trigMask = zeroPad(parseInt(instructionBin.substring(0, 28), 2).toString(16).toUpperCase(), 7);
			
			instruction["assembly"] = "TRIG_MASK 0x" + trigMask;
			endSeq = false;
		} else if(command === '1100') { // END
			instruction["assembly"] = "END";
			instructionLength = commandLength['END'];
			var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
			endSeq = true;
		} else if(command === '1101') { // REG_WRITE_BIT_PAGE0_IMM
			instructionLength = commandLength['REG_WRITE_BIT_PAGE0_IMM'];
            var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);            
            var bitSel = parseInt(instructionBin.substring(0,3), 2);
            var data = instructionBin.substring(3,4);
            var addr = zeroPad(parseInt(instructionBin.substring(4,12), 2).toString(16).toUpperCase(), 2);
            
            instruction["assembly"] = "REG_WRITE_BIT_PAGE0_IMM ADDR=0x" + addr + " BIT=" + bitSel + " DATA=0x" + data;
            instructionSetVersion = 2;
			endSeq = false;
		} else if(command === '1110') { // REG_WRITE_WIN_PAGE0_IMM
            instructionLength = commandLength['REG_WRITE_WIN_PAGE0_IMM'];
            var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
            var shift = parseInt(instructionBin.substring(0,2), 2);
            var mask = zeroPad(parseInt(instructionBin.substring(2,7), 2).toString(16).toUpperCase(), 2);
            var data = zeroPad(parseInt(instructionBin.substring(7,12), 2).toString(16).toUpperCase(), 2);
            var addr = zeroPad(parseInt(instructionBin.substring(12,20), 2).toString(16).toUpperCase(), 2);
            
			instruction["assembly"] = "REG_WRITE_WIN_PAGE0_IMM ADDR=0x" + addr + " DATA=0x" + data + " MASK=0x" + mask + " SHIFT=" + shift;
            instructionSetVersion = 2;
			endSeq = false;
		} else if(command === '1111') { // SREG_WRITE_IMM
			instructionLength = commandLength['SREG_WRITE_IMM'];
            var instructionBin = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
            var data = zeroPad(parseInt(instructionBin.substring(0,8), 2).toString(16).toUpperCase(), 2);
            var sreg = "R" + parseInt(instructionBin.substring(8,10), 2);
            
            instruction["assembly"] = "SREG_WRITE_IMM REG=" + sreg + " DATA=0x" + data;
            instructionSetVersion = 2;
			endSeq = false;
		} else {
			if(command !== '0' && command !== '00' && command !== '000') { // Only throw an error if we are not at the end of the sequence, where we would see a shorter command of zeroes
				console.log("Unexpected command '" + command + "', expecting 4-bit binary command");
				return "";
			} else {	// At end of sequence
				break;
			}
		}
		
		instruction["binary"] = binaryString.substring(binaryString.length-binaryIndex-instructionLength, binaryString.length-binaryIndex);
		instructionList.push(instruction);
		binaryIndex += instructionLength;
	}
	
    // Remove all-0 instructions at the end
    while(instructionList[instructionList.length-1].binary === "0".repeat(28)) {
        instructionList.pop();
    }
    
    instructionList.unshift({assembly: "pfsm_start:"});
    
    if(instructionSetVersion !== 1) {
        instructionList.unshift({assembly: "; instruction_set_version " + instructionSetVersion});
    }
          
	return instructionList;
}

// Takes a list of instructions, and returns back a string in 32-bit lines
var formatBits = function(instructions) {
	var binaryArray = [];
	var currLine = "";
	
	for(var i=0; i<instructions.length; i++) {
		var instruction = instructions[i];
		if(currLine.length + instruction.length <= 32) {
			currLine = instruction + currLine;
		} else {
			var bitsRemaining = 32-currLine.length;
			currLine = instruction.substring(instruction.length - bitsRemaining) + currLine;
			binaryArray.push(currLine);
			currLine = instruction.substring(0, instruction.length-bitsRemaining);
		}
	}
	
	if(currLine.length < 32) {
		currLine = zeroPad(currLine, 32);
	}
	binaryArray.push(currLine);
	
	var binaryString = "";
	for(i=0; i<binaryArray.length; i++) {
		binaryString += binaryArray[i] + "\n";
	}
	
	return binaryString;
}

var createDebugString = function(instructionsParsed, instructionAddrs, reverseSymbols) {
	var debugString = ""
	for(var i=0; i<instructionsParsed.length; i++) {
		if(reverseSymbols.hasOwnProperty(i)) {
			debugString += reverseSymbols[i] + ":\n";
		}
        var instructionStr = parsedToString(instructionsParsed[i])
		debugString += "0x" + zeroPad(instructionAddrs[i].toString(16), 4) + ": " + instructionStr + "\n";
	}
	return debugString;
}

// Adds leading zeroes to a string, to get it to the provided length.
// Example zeroPad("11", 8) = "00000011"
var zeroPad = function(str, length) {
	
	padding = "";
	for(var i=0; i<length-str.length; i++) {
		padding += "0";
	}
	return padding + str;
}

// Calculates address mapping from PFSM address to input address.
// The watchdog page is assembled as 0x3XX, but is converted in assembly to 0x4XX
// Returns -1 on error.
var disassembleAddress = function(address) {
	address = parseInt(address, 2);
	if(address >= 0x300) {
		address += 0x100;
	}
	return address;
}

var adjustSymbolAddresses = function(symbols, startAddress, amount) {
    for(key in symbols.keys) {
        if(symbols[key] >= startAddress) {
            symbols[key] -= amount;
        }
    }
}

// currentInstruction is a global variable set in the main assemble loop
var logMessage = function(message) {
    console.log("\nInstruction: " + currentInstruction + "\n" + message);
}

const errorTypes = {
	"ERR_NO_PFSM_START": 1,
	"ERR_INVALID_INSTRUCTION_SET_VERSION": 2,
	"ERR_DUPLICATE_LABEL": 3,
	"ERR_TRIG_SET_NOT_FIRST": 4,
	"ERR_TRIG_SET_OUT_OF_ORDER": 5,
	"ERR_INVALID_INSTRUCTION": 6,
	"ERR_WAIT_NO_SKIP_OR_DEST": 7,
	"ERR_WAIT_BOTH_SKIP_AND_DEST": 8,
	"ERR_TRIG_SET_IMM_REENTRANT": 9,
	"ERR_WRONG_NUMBER_OF_ARGUMENTS": 10,
	"ERR_MISSING_ARGUMENT": 11,
	"ERR_INVALID_ARGUMENT_VALUE": 12,
	"ERR_ADDRESS_PAGE_3": 13,
	"ERR_ADDRESS_OUT_OF_RANGE": 14,
	"ERR_DELAY_BAD_FORMAT": 15,
	"ERR_DELAY_OUT_OF_RANGE": 16,
	"ERR_DELAY_WRONG_STEP_SIZE": 17,
	"ERR_DELAY_STEP_NOT_SET": 18,
	"ERR_MISSING_BYPASS": 19,
	"ERR_INVALID_DESTINATION_NAME": 20,
	"ERR_INVALID_DESTINATION_ADDRESS": 21,
	"ERR_INVALID_LITERAL": 22
};

const warningTypes = {
	"WARN_INSERT_TRIGGER": 1,
	"WARN_DELAY_ROUND_TO_ZERO": 2,
	"WARN_DELAY_NOT_WITHIN_TOLERANCE": 3,
	"WARN_BUCK_BYPASS_IGNORED": 4
};

var newError = function(name, message, value) {
	return {
		number: errorTypes[name],
		name: name,
		instruction: "",
		message: message,
		value: value
	};
};

var newWarning = function(name, message, value) {
	return {
		number: warningTypes[name],
		name: name,
		instruction: "",
		message: message,
		value: value
	};
}
